//----------------------------------------------------------------------------
// MLTLANG.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: MLTLANG.pas
//----------------------------------------------------------------------------
#ifndef MLTLANGHPP
#define MLTLANGHPP
//----------------------------------------------------------------------------
#include <DB.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
#include <DsgnIntf.hpp>
#include <TypInfo.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Mltlang
{
//-- type declarations -------------------------------------------------------
typedef short tOLSize;

typedef void *TObjects[16384];

typedef TObjects *pObjects;

class __declspec(delphiclass) TObjectList;
class __declspec(pascalimplementation) TObjectList : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FDestroy;
	TObjects *FList;
	short FCount;
	short FCapacity;
	
protected:
	virtual void __fastcall Error(void);
	virtual void __fastcall Grow(void);
	virtual void __fastcall Put(short Index, System::TObject* Item);
	System::TObject* __fastcall Get(short Index);
	void __fastcall SetCapacity(short NewCapacity);
	void __fastcall SetCount(short NewCount);
	void * __fastcall Allocate(long Size);
	virtual void __fastcall FreeItem(void * AnItem);
	
public:
	__fastcall TObjectList(void);
	__fastcall TObjectList(bool DestroyObjects, short InitialCapacity);
	__fastcall virtual ~TObjectList(void);
	virtual short __fastcall AddObject(System::TObject* Item);
	virtual void __fastcall Clear(void);
	void __fastcall Delete(short Index);
	void __fastcall DeleteAll(void);
	void __fastcall FreeAll(void);
	void __fastcall FreeAt(short Index);
	void __fastcall FreeObject(System::TObject* Item);
	virtual short __fastcall IndexOf(System::TObject* Item);
	virtual void __fastcall Insert(short Index, System::TObject* Item);
	void __fastcall Move(short CurIndex, short NewIndex);
	void __fastcall Pack(void);
	__fastcall TObjectList(const System::AnsiString FileName);
	void __fastcall SaveToStream(const System::AnsiString FileName);
	void __fastcall LoadFromStream(const System::AnsiString FileName);
	virtual void __fastcall ReadData(Classes::TStream* S);
	virtual void __fastcall WriteData(Classes::TStream* S);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual System::TObject* __fastcall First(void);
	virtual System::TObject* __fastcall Last(void);
	virtual System::TObject* __fastcall Next(System::TObject* Item, bool Forward);
	void __fastcall ForEach(void * Action);
	System::TObject* __fastcall LastThat(void * Test);
	System::TObject* __fastcall FirstThat(void * Test);
	__property short Capacity = {read=FCapacity, write=SetCapacity, nodefault};
	__property System::TObject* Items[short Index] = {read=Get, write=Put/*, default*/};
	__property short Count = {read=FCount, nodefault};
	__property bool DestroyObjects = {read=FDestroy, write=FDestroy, nodefault};
};

class __declspec(delphiclass) TAbsMemStream;
class __declspec(pascalimplementation) TAbsMemStream : public Classes::TStream
{
	typedef Classes::TStream inherited;
	
private:
	void *FMemory;
	long FSize;
	long FPosition;
	
public:
	__fastcall TAbsMemStream(void * UseBuf, long MaxSize);
	virtual long __fastcall Read(void *Buffer, long Count);
	virtual long __fastcall Write(const void *Buffer, long Count);
	virtual long __fastcall Seek(long Offset, Word Origin);
	__property long Position = {read=FPosition, nodefault};
	__property void * Memory = {read=FMemory, nodefault};
	__property long Size = {read=FSize, nodefault};
public:
	/* TObject.Destroy */ __fastcall virtual ~TAbsMemStream(void) { }
	
};

class __declspec(delphiclass) TSortedObjectList;
class __declspec(pascalimplementation) TSortedObjectList : public TObjectList
{
	typedef TObjectList inherited;
	
private:
	TDuplicates FDuplicates;
	
protected:
	virtual void * __fastcall KeyOf(System::TObject* Item);
	virtual void __fastcall Put(short Index, System::TObject* Item);
	
public:
	__fastcall TSortedObjectList(Classes::TDuplicates WithDuplicates);
	virtual void __fastcall ReadData(Classes::TStream* S);
	virtual void __fastcall WriteData(Classes::TStream* S);
	virtual int __fastcall Compare(void * Key1, void * Key2) = 0;
	virtual short __fastcall AddObject(System::TObject* Item);
	virtual bool __fastcall Search(void * Key, short &Index);
	virtual void __fastcall Insert(short Index, System::TObject* Item);
	virtual short __fastcall IndexOf(System::TObject* Item);
	__property System::TObject* Items[short Index] = {read=Get};
	__property Classes::TDuplicates Duplicates = {read=FDuplicates, nodefault};
public:
	/* TObjectList.CreateWithOptions */ __fastcall TSortedObjectList(bool DestroyObjects, short InitialCapacity
		) : Mltlang::TObjectList(DestroyObjects, InitialCapacity) { }
	/* TObjectList.Destroy */ __fastcall virtual ~TSortedObjectList(void) { }
	/* TObjectList.CreateFromStream */ __fastcall TSortedObjectList(const System::AnsiString FileName) : 
		Mltlang::TObjectList(FileName) { }
	
};

class __declspec(delphiclass) EMLangInvalid;
class __declspec(pascalimplementation) EMLangInvalid : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EMLangInvalid(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EMLangInvalid(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EMLangInvalid(int Ident) : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ __fastcall EMLangInvalid(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EMLangInvalid(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EMLangInvalid(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EMLangInvalid(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EMLangInvalid(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EMLangInvalid(void) { }
	
};

enum TCompKind { ckString, ckStringlist };

class __declspec(delphiclass) TCompInfo;
class __declspec(pascalimplementation) TCompInfo : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	Classes::TComponent* Obj;
	System::AnsiString PropName;
	System::AnsiString CompName;
	long CompIndex;
	long MaxItems;
	__fastcall virtual TCompInfo(void);
	__fastcall virtual ~TCompInfo(void);
	virtual void __fastcall Store(Classes::TStream* S);
	virtual void __fastcall Load(Classes::TStream* S);
	virtual System::AnsiString __fastcall GetValue(int LangIndex);
	virtual void __fastcall SetValue( System::AnsiString Val, int LangIndex);
	virtual Classes::TStrings* __fastcall GetStringList(int LangIndex);
	virtual void __fastcall SetStringList(Classes::TStrings* Val, int LangIndex);
	virtual System::AnsiString __fastcall GetStringListValue(int LangIndex, int Index);
	virtual void __fastcall SetStringListValue( System::AnsiString Val, int LangIndex, int Index);
	virtual void __fastcall Info2Comp(Classes::TComponentState ComponentState) = 0;
	virtual void __fastcall Comp2Info(void) = 0;
};

class __declspec(delphiclass) TCompInfoString;
class __declspec(pascalimplementation) TCompInfoString : public TCompInfo
{
	typedef TCompInfo inherited;
	
private:
	Classes::TStringList* Values;
	
public:
	__fastcall virtual TCompInfoString(void);
	__fastcall virtual ~TCompInfoString(void);
	virtual void __fastcall Store(Classes::TStream* S);
	virtual void __fastcall Load(Classes::TStream* S);
	virtual System::AnsiString __fastcall GetValue(int LangIndex);
	virtual void __fastcall SetValue( System::AnsiString Val, int LangIndex);
	virtual System::AnsiString __fastcall GetStringListValue(int LangIndex, int Index);
	virtual void __fastcall SetStringListValue( System::AnsiString Val, int LangIndex, int Index);
	virtual void __fastcall Info2Comp(Classes::TComponentState ComponentState);
	virtual void __fastcall Comp2Info(void);
};

class __declspec(delphiclass) TCompInfoStringList;
class __declspec(pascalimplementation) TCompInfoStringList : public TCompInfo
{
	typedef TCompInfo inherited;
	
private:
	Classes::TList* Values;
	
public:
	__fastcall virtual TCompInfoStringList(void);
	__fastcall virtual ~TCompInfoStringList(void);
	virtual void __fastcall Store(Classes::TStream* S);
	virtual void __fastcall Load(Classes::TStream* S);
	virtual Classes::TStrings* __fastcall GetStringList(int LangIndex);
	virtual void __fastcall SetStringList(Classes::TStrings* Val, int LangIndex);
	virtual System::AnsiString __fastcall GetStringListValue(int LangIndex, int Index);
	virtual void __fastcall SetStringListValue( System::AnsiString Val, int LangIndex, int Index);
	virtual void __fastcall Info2Comp(Classes::TComponentState ComponentState);
	virtual void __fastcall Comp2Info(void);
};

class __declspec(delphiclass) TInfoList;
class __declspec(pascalimplementation) TInfoList : public TObjectList
{
	typedef TObjectList inherited;
	
private:
	TCompInfo* __fastcall GetItem(int Index);
	void __fastcall PutItem(int Index, TCompInfo* Item);
	
public:
	HIDESBASE void __fastcall Assign(TInfoList* Src);
	int __fastcall FindCompInfo( System::AnsiString CompName,  System::AnsiString PropName);
	System::AnsiString __fastcall FindTranslation( System::AnsiString DefaultText, int LangIndex);
	void __fastcall FillTranslation(TInfoList* Src, int LangIndex);
	__property TCompInfo* Items[int Index] = {read=GetItem, write=PutItem};
public:
	/* TObjectList.Create */ __fastcall TInfoList(void) : Mltlang::TObjectList() { }
	/* TObjectList.CreateWithOptions */ __fastcall TInfoList(bool DestroyObjects, short InitialCapacity
		) : Mltlang::TObjectList(DestroyObjects, InitialCapacity) { }
	/* TObjectList.Destroy */ __fastcall virtual ~TInfoList(void) { }
	/* TObjectList.CreateFromStream */ __fastcall TInfoList(const System::AnsiString FileName) : Mltlang::
		TObjectList(FileName) { }
	
};

class __declspec(delphiclass) TDictionaryItem;
class __declspec(pascalimplementation) TDictionaryItem : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Classes::TStringList* Values;
	
public:
	__fastcall TDictionaryItem(void);
	__fastcall virtual ~TDictionaryItem(void);
	virtual void __fastcall Store(Classes::TStream* S);
	virtual void __fastcall Load(Classes::TStream* S);
	System::AnsiString __fastcall GetValue(int LangIndex);
	void __fastcall SetValue( System::AnsiString Val, int LangIndex);
};

class __declspec(delphiclass) TDictionary;
class __declspec(pascalimplementation) TDictionary : public TObjectList
{
	typedef TObjectList inherited;
	
public:
	System::AnsiString __fastcall FindTranslation( System::AnsiString SrcText, int SrcInd, int DestInd)
		;
	void __fastcall AddTranslation( System::AnsiString SrcText,  System::AnsiString DestText, int SrcInd
		, int DestInd);
	void __fastcall UpdateDict(TDictionary* Dest, TInfoList* Src);
public:
	/* TObjectList.Create */ __fastcall TDictionary(void) : Mltlang::TObjectList() { }
	/* TObjectList.CreateWithOptions */ __fastcall TDictionary(bool DestroyObjects, short InitialCapacity
		) : Mltlang::TObjectList(DestroyObjects, InitialCapacity) { }
	/* TObjectList.Destroy */ __fastcall virtual ~TDictionary(void) { }
	/* TObjectList.CreateFromStream */ __fastcall TDictionary(const System::AnsiString FileName) : Mltlang::
		TObjectList(FileName) { }
	
};

typedef void __fastcall (__closure *TBeforeChangingEvent)(System::TObject* Sender, bool &Allowed);

class __declspec(delphiclass) TMltLang;
class __declspec(pascalimplementation) TMltLang : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TInfoList* FItems;
	System::AnsiString FDefDictionary;
	Classes::TNotifyEvent FOnParentShow;
	Classes::TNotifyEvent FOnLanguageChanged;
	TBeforeChangingEvent FOnBeforeChanging;
	Forms::TForm* __fastcall FindParentForm(void);
	TInfoList* __fastcall GetItems(void);
	void __fastcall SetItems(TInfoList* Value);
	void __fastcall RefreshList(TInfoList* Itemlist);
	void __fastcall CheckList(void);
	void __fastcall SetPropertyValuesInForm(void);
	void __fastcall GetPropertyValuesInForm(void);
	bool __fastcall UpdateTheData(void);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	void __fastcall SetActiveLang(int NewVal);
	int __fastcall GetActiveLang(void);
	void __fastcall SetMaxLang(int NewVal);
	int __fastcall GetMaxLang(void);
	
public:
	__fastcall virtual TMltLang(Classes::TComponent* AOwner);
	__fastcall virtual ~TMltLang(void);
	virtual void __fastcall Loaded(void);
	void __fastcall OwnerFormShow(System::TObject* Sender);
	void __fastcall Testfunction(void);
	
__published:
	__property int ActiveLang = {read=GetActiveLang, write=SetActiveLang, stored=false, nodefault};
	__property int MaxLang = {read=GetMaxLang, write=SetMaxLang, nodefault};
	__property TInfoList* Items = {read=GetItems, write=SetItems, stored=UpdateTheData, nodefault};
	__property System::AnsiString DefDictionary = {read=FDefDictionary, write=FDefDictionary, stored=true
		, nodefault};
	__property TBeforeChangingEvent OnBeforeChanging = {read=FOnBeforeChanging, write=FOnBeforeChanging
		};
	__property Classes::TNotifyEvent OnLanguageChanged = {read=FOnLanguageChanged, write=FOnLanguageChanged
		};
};

class __declspec(delphiclass) TTextList;
class __declspec(pascalimplementation) TTextList : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TStringList* FItems;
	Classes::TStrings* __fastcall GetItems(void);
	void __fastcall SetItems(Classes::TStrings* Value);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	__fastcall virtual TTextList(Classes::TComponent* AOwner);
	__fastcall virtual ~TTextList(void);
	
__published:
	__property Classes::TStrings* Items = {read=GetItems, write=SetItems, stored=false, nodefault};
};

class __declspec(delphiclass) TPropertyEditorFrm;
class __declspec(pascalimplementation) TPropertyEditorFrm : public Forms::TForm
{
	typedef Forms::TForm inherited;
	
__published:
	Extctrls::TPanel* Panel1;
	Grids::TStringGrid* StringGrid;
	Extctrls::TPanel* Panel2;
	Extctrls::TPanel* Panel3;
	Buttons::TSpeedButton* SpeedButtonUpdate;
	Buttons::TSpeedButton* SpeedButtonDeleteItem;
	Buttons::TSpeedButton* SpeedButtonAutofillItem;
	Extctrls::TPanel* Panel4;
	Buttons::TBitBtn* HelpBtn;
	Buttons::TBitBtn* CancelBtn;
	Buttons::TBitBtn* OKBtn;
	Menus::TPopupMenu* PopupMenu1;
	Menus::TMenuItem* DeleteItem;
	Menus::TMenuItem* AutofillItem;
	Menus::TMenuItem* Update;
	Menus::TMenuItem* AutofillColumn;
	Menus::TMenuItem* AutofillTable;
	Buttons::TSpeedButton* SpeedButtonAutofillCol;
	Buttons::TSpeedButton* SpeedButtonAutofill;
	Buttons::TSpeedButton* SpeedButtonExport;
	Buttons::TSpeedButton* SpeedButtonImport;
	Dialogs::TOpenDialog* OpenDialog;
	Dialogs::TSaveDialog* SaveDialog;
	Buttons::TSpeedButton* SpeedButtonSaveToOtherDictionary;
	Buttons::TSpeedButton* SpeedButtonOpenDictionary;
	Menus::TMenuItem* DeleteBlankEntries;
	Extctrls::TPanel* LabelDictionary;
	Buttons::TSpeedButton* SpeedButtonDeleteBlankItems;
	Buttons::TSpeedButton* SpeedButtonSaveToDictionary;
	void __fastcall PopupClick(System::TObject* Sender);
	void __fastcall SpeedButtonDictionaryClick(System::TObject* Sender);
	void __fastcall FormActivate(System::TObject* Sender);
	void __fastcall HelpBtnClick(System::TObject* Sender);
	
private:
	TInfoList* List;
	TMltLang* CmpMlt;
	TDictionary* Dictionary;
	void __fastcall GridAddPropName( System::AnsiString Name, int Row);
	void __fastcall DeleteListItem(int Index);
	void __fastcall Grid2List(void);
	void __fastcall List2Grid(void);
public:
	/* TForm.Create */ __fastcall virtual TPropertyEditorFrm(Classes::TComponent* AOwner) : Forms::TForm(
		AOwner) { }
	/* TForm.CreateNew */ __fastcall TPropertyEditorFrm(Classes::TComponent* AOwner, int Dummy) : Forms::
		TForm(AOwner, Dummy) { }
	/* TForm.Destroy */ __fastcall virtual ~TPropertyEditorFrm(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TPropertyEditorFrm(HWND ParentWindow) : Forms::TForm(ParentWindow
		) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define cMaxList (Word)(16384)
extern void __fastcall DoRegisterClass(void * const LoadProc, void * const StoreProc, System::TMetaClass* 
	Sender);
extern bool __fastcall IsRegistered(System::TMetaClass* AClass);
extern System::TObject* __fastcall CopyOf(System::TObject* Source);
extern System::TObject* __fastcall ReadObjectFromStream(Classes::TStream* S);
extern void __fastcall WriteObjectToStream(System::TObject* Source, Classes::TStream* S);
extern Word __fastcall RegisterClipBoardType(const System::AnsiString TypeName);
extern bool __fastcall CopyObjectToClipboard(Word ClipType, System::TObject* Source);
extern System::TObject* __fastcall PasteObjectFromClipboard(Word ClipType);
extern void __fastcall Register(void);

}	/* namespace Mltlang */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Mltlang;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// MLTLANG
